VERSION 5.00
Object = "{86CF1D34-0C5F-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCT2.OCX"
Begin VB.Form frmProdSort 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Form1"
   ClientHeight    =   3465
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   10335
   ControlBox      =   0   'False
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3465
   ScaleWidth      =   10335
   ShowInTaskbar   =   0   'False
   Begin VB.CommandButton btnSetDelay 
      Caption         =   "Set &Delay"
      Height          =   300
      Left            =   7500
      TabIndex        =   4
      ToolTipText     =   "Change write back loop delay"
      Top             =   3100
      Width           =   1000
   End
   Begin VB.CommandButton btnExit 
      Caption         =   "E&xit"
      Height          =   300
      Left            =   9300
      TabIndex        =   5
      ToolTipText     =   "Exit macro"
      Top             =   3100
      Width           =   1000
   End
   Begin VB.CommandButton btnSendToCatList 
      Caption         =   "&Write back"
      Height          =   300
      Left            =   2150
      TabIndex        =   3
      ToolTipText     =   "Rearrange Catia list according to VB-list"
      Top             =   3100
      Width           =   1000
   End
   Begin MSComCtl2.UpDown UD1 
      Height          =   2985
      Left            =   10051
      TabIndex        =   6
      ToolTipText     =   "Select scroll entry within list"
      Top             =   50
      Width           =   240
      _ExtentX        =   423
      _ExtentY        =   5265
      _Version        =   393216
      BuddyControl    =   "lb_Prods"
      BuddyDispid     =   196614
      OrigLeft        =   8400
      OrigTop         =   1440
      OrigRight       =   8640
      OrigBottom      =   2175
      Enabled         =   -1  'True
   End
   Begin VB.CommandButton btnSortList 
      Caption         =   "&Sort"
      Height          =   300
      Left            =   1100
      TabIndex        =   2
      ToolTipText     =   "Sort VB-list alphabetically"
      Top             =   3100
      Width           =   1000
   End
   Begin VB.CommandButton btnGetList 
      Caption         =   "&Read List"
      Height          =   300
      Left            =   50
      TabIndex        =   1
      ToolTipText     =   "Read list of products from Catia"
      Top             =   3100
      Width           =   1000
   End
   Begin VB.ListBox lb_Prods 
      Height          =   2985
      Left            =   50
      TabIndex        =   0
      ToolTipText     =   "Select entry to scroll"
      Top             =   50
      Width           =   10000
   End
   Begin VB.Label lblDelay 
      Caption         =   "Delay: "
      Height          =   255
      Left            =   6200
      TabIndex        =   8
      Top             =   3100
      Width           =   1335
   End
   Begin VB.Label lblListCount 
      Caption         =   "Entries: 0000"
      Height          =   255
      Left            =   5000
      TabIndex        =   7
      Top             =   3100
      Width           =   1455
   End
End
Attribute VB_Name = "frmProdSort"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Dim arrProds() As String            'array for product names

Private Sub btnExit_Click()
   Unload Me
End Sub

Private Sub btnGetList_Click()
   GetProductsListFromList "Graph tree reordering", arrProds
   lblListCount.Caption = "Entries: " & Format$(lb_Prods.ListCount, "0000")
End Sub

Private Sub btnSetDelay_Click()
   Dim strRet As String
   
SetDelay_Again:
   strRet = InputBox("Enter delay value!(100 - 1000)", "Set delay value", 300)
   If strRet <> "" Then                   'then check the value entered
      If Val(strRet) >= 100 And Val(strRet) <= 1000 Then
         lDelay = CLng(strRet)            'if value OK set new delay time
         lblDelay.Caption = "Delay: " & strRet & "ms"
      Else                                'invalid entry
         Beep
         GoTo SetDelay_Again              'do it again
      End If
   End If
End Sub

Private Sub btnSortList_Click()
Dim n As Integer
   lb_Prods.Clear                                  'clear list
   QuickSort arrProds                              'sort array
   For n = 0 To UBound(arrProds)
      lb_Prods.AddItem arrProds(n)                 'add to list
   Next
   lblListCount.Caption = "Entries: " & Format$(lb_Prods.ListCount, "0000")
End Sub

Private Sub Form_Load()
   
   Caption = App.EXEName & " V" & App.Major & "." & App.Minor & "." & App.Revision
   GetCatiaObjectProdSort
      
   If CATIA Is Nothing Then                           'this should not normally happen
      Unload Me
      Exit Sub
   End If
   
   SetTopMost hwnd, True

   lDelay = 300
   lblDelay.Caption = "Delay: " & CStr(lDelay) & "ms"

End Sub

Private Sub Form_Resize()
   Dim l As Single
   Dim t As Single
   
   l = (Screen.Width - Width) \ 2      'center form
   t = (Screen.Height - Height) \ 2
   Move l, t
End Sub

Private Sub Form_Unload(Cancel As Integer)
   SetTopMost hwnd, False           'reset topmost
   End                              'quit
End Sub

'---------------------------------------------------------------------------------------
' Procedure : btnSendToCatList_Click
' Author    : jherzog
' Date      : 14.02.2015
' Time      : 21:49
' Languages : VB6 Pro SP6
' V5-Release: V5R19/21
' Purpose   : rearrange catia products list box according to sorted vb list box
' Parms     : -
' Ret. Value: -
'
' Syntax    : - (Press the button
'
' Prereqs   : Filled vb list box
' Remarks   : If the catia list box is not resized prior to sending the rearranging
'           : commands, the routine fails miserably.
'           : Increasing the loop delay time would not remedy the situation.
'---------------------------------------------------------------------------------------
'
Private Sub btnSendToCatList_Click()
   Dim iOldPos As Integer
   Dim n As Integer
   
   btnGetList.Enabled = False          'no reentry please
   btnSortList.Enabled = False
   btnSendToCatList.Enabled = False
   btnExit.Enabled = False
   btnSetDelay.Enabled = False
   
   MousePointer = vbHourglass
   ResizeDialogWindow                  'show all entries in catia dialog list box
   
   For n = 0 To lb_Prods.ListCount - 1 'work thru sorted vb-list
      iOldPos = SendMessageString(hWndListBox, LB_SELECTSTRING, -1&, lb_Prods.List(n))
      ClickListItem iOldPos            'select the element to move
      PushFreeMove                     'select free move button
      ClickListItem n                  'select destination
      Sleep lDelay                     'give catia time to react
      DoEvents
   Next
   
   MousePointer = vbNormal
   
   btnGetList.Enabled = True           'back to normal
   btnSortList.Enabled = True
   btnSendToCatList.Enabled = True
   btnExit.Enabled = True
   btnSetDelay.Enabled = True
End Sub
'click an entry in the catia 'Graph tree reordering' list box
'---------------------------------------------------------------------------------------
Sub ClickListItem(iItem As Integer)
   Dim rc As RECT
      
   SendMessageAny hWndListBox, LB_GETITEMRECT, ByVal CLng(iItem), rc 'get size/position
   'send button-down/button-up combo
   SendMessageByNum hWndListBox, WM_LBUTTONDOWN, 0&, _
      MAKELPARAM((rc.Right - rc.Left) \ 2, rc.Top + (rc.Bottom - rc.Top) \ 2)
   SendMessageByNum hWndListBox, WM_LBUTTONUP, 0&, _
      MAKELPARAM((rc.Right - rc.Left) \ 2, rc.Top + (rc.Bottom - rc.Top) \ 2)
End Sub

'scroll selected product in vb list
Private Sub UD1_DownClick()
   Dim strDummy As String
   Dim iNewPos As Integer
   Dim iOldPos As Integer

   If lb_Prods.SelCount = 1 Then                      'one entry needs to be selected
      iOldPos = lb_Prods.ListIndex                    'get the index positon
      
      If iOldPos + 1 > lb_Prods.ListCount - 1 Then
         iNewPos = 0                                  'wrap when at end
      Else
         iNewPos = iOldPos + 1                        'or increase by one
      End If
      
      strDummy = lb_Prods.List(iNewPos)               'buffer the current entry
      lb_Prods.List(iNewPos) = lb_Prods.List(iOldPos) 'swap places
      lb_Prods.List(iOldPos) = strDummy               '
      lb_Prods.ListIndex = iNewPos                    'adjust index
   End If
End Sub

'scroll selected product in vb list
Private Sub UD1_UpClick()
   Dim strDummy As String
   Dim iNewPos As Integer
   Dim iOldPos As Integer

   If lb_Prods.SelCount = 1 Then
      iOldPos = lb_Prods.ListIndex
      
      If iOldPos - 1 < 0 Then
         iNewPos = lb_Prods.ListCount - 1
      Else
         iNewPos = iOldPos - 1                        'or decrease by one
      End If
      
      strDummy = lb_Prods.List(iNewPos)
      lb_Prods.List(iNewPos) = lb_Prods.List(iOldPos)
      lb_Prods.List(iOldPos) = strDummy
      lb_Prods.ListIndex = iNewPos
   End If
End Sub
'push the catia 'Free Move' button
Sub PushFreeMove()
   SendMessageByNum hWndLBFreeMove, BM_CLICK, 0&, 0&  'send click message
End Sub

'push the catia 'Move Up' button
Sub PushUpCat(iTimes As Integer)
   Dim n As Integer
   For n = 1 To iTimes
      SendMessageByNum hWndLBUpArrow, BM_CLICK, 0&, 0&
   Next
End Sub

'push the catia 'Move Down' button
Sub PushDownCat(iTimes As Integer)
   Dim n As Integer
   
   For n = 1 To iTimes
      SendMessageByNum hWndLBDownArrow, BM_CLICK, 0&, 0&
   Next
End Sub
'---------------------------------------------------------------------------------------
Sub ResizeDialogWindow()
   'resize the dialog window vertically to show all entries
   Dim rc As RECT
   Dim rc_Item As RECT
   Dim rc_LB As RECT
   Dim ret As Long
   Dim lDeltaH As Long
   
   GetWindowRect hWndDlg, rc                                   'get size of dialog window
   GetWindowRect hWndListBox, rc_LB                            'get size of listbox
   SendMessageAny hWndListBox, LB_GETITEMRECT, ByVal 0&, rc_Item  'get size of 1. entry
   lDeltaH = lb_Prods.ListCount * (rc_Item.Bottom - rc_Item.Top + 1) _
               - (rc_LB.Bottom - rc_LB.Top + 1)                'calc delta needed
   If lDeltaH <= 0 Then Exit Sub                               'if big enough, quit
   ret = SetWindowPos(hWndDlg, 0, rc.Left, rc.Top, rc.Right - rc.Left, _
      rc.Bottom - rc.Top + lDeltaH, SWP_NOACTIVATE)            'resize dialog
End Sub
